/* Data set:
*/

// Define beginning and end of estimation sample
if dataselstr $== "us";
  load path = ^datapath YYall[]= "data_us.txt";
  // date   y growth	c growth	infl	R		
  // logY   logT	    logCBO	    logC    logCY
  YYall        = reshape(YYall,rows(YYall)/10,10);
  tiall        = YYall[1:rows(YYall),1];
  YYall        = YYall[1:rows(YYall),2:10];
  nobsall      = rows(YYall);
  Tfirst = 1984.00;
  Tlast  = 2015.00;
  YYmaskall = zeros(rows(YYall),1);
  MM0 = eye(3);
  MM1 = eye(3);	
elseif dataselstr $== "jp";
  load path = ^datapath YYall[]= "data_jp.txt";
  YYall        = reshape(YYall,rows(YYall)/10,10);
  tiall        = YYall[1:rows(YYall),1];
  YYall        = YYall[1:rows(YYall),2:10];
  nobsall      = rows(YYall);
  Tfirst = 1981.00;
  Tlast  = 2015.00;
  YYmaskall = zeros(rows(YYall),1);
  // adjust inflation for periods 1997:Q2, 2008:Q4, 2014:Q2
  // obs 66, 112, 134
  YYmaskall[66]  = 1;
  YYmaskall[112] = 1;
  YYmaskall[134] = 1;
  MM0 = eye(3);	
  MM1 = (1 ~ 0)|
	    (0 ~ 0)|
        (0 ~ 1); 	
endif;

Tfirst_ind    = maxindc(tiall .== Tfirst);
Tlast_ind     = maxindc(tiall .== Tlast);

YY = YYall[Tfirst_ind:Tlast_ind,.];
ti = tiall[Tfirst_ind:Tlast_ind,.];
YYmask = YYmaskall[Tfirst_ind:Tlast_ind,.];
