/*************************************************************
** filename:    dsge_statemom.g
** description: Compute  mean and based on
**              output of particle filter
*************************************************************/

new;
closeall; 
cls;

#include dsge_spec.g; 

// Load Particles
// particle_values
// each row: ti, n_particles*n_states

sun_choice = 1;

if dataselstr == "us";
   if sun_choice == 0;
      fileext = "_gs000ME07R02";
      extract_parperquarter = 40;
   else;
      fileext = "_gs111ME07R02";
      extract_parperquarter = 8; 	
   endif;
elseif dataselstr == "jp";
   if sun_choice == 0;	
      fileext = "_gs000ME07R02";	
      extract_parperquarter = 3;
   else;
      fileext = "_gs111ME07R02";	
      extract_parperquarter = 3;
	  endif;
endif;	




lparticles       = resupath $+ "\\particle_values" $+ fileext  ;
open fhparticles = ^lparticles for read;

ti = 0;
state_mean = zeros(1,n_states);
state_low  = zeros(1,n_states);
state_high = zeros(1,n_states);

// selection vector for particles
//extract_parperquarter = extract_total/extract_quarters;
rndseed 1234;
_particles_select = sortc(ceil(n_particles*rndu(extract_parperquarter,1)),1);


// Start Log file
outstr = resupath  $+ "\\" $+ ftos(timedt,"%*.*lf",1,0) $+ "stateextract" $+ fileext $+ ".log"; 
output file = ^outstr reset;

"Model             " modelid $lmodel;
"Data              " $dataselstr;
"Initial Particles " n_particles_initial;
"Particles         " n_particles;
"Measurement errors y, p, r" sigmy sigmp sigmr;
"--------------------------------------------";
"";
pause(1e-5);


eofloop = 0;

do until eofloop; 

   // read particles for a particular time period
   particles = readr( fhparticles, 1 );
   
   // re-arrange particles
   ti = particles[1];
   ti_vec = ones(rows(_particles_select),1)*ti;
   particles = reshape(particles[2:n_particles*n_states+1],n_particles,n_states); 

   state_i = particles[_particles_select,.];
   state_i_del = state_i[.,20] .NE sun_choice;
	
   state_i = delif(state_i,state_i_del); 
   ti_vec  = delif(ti_vec,state_i_del);
   if ismiss(state_i) NE 1;
	  ti_vec~state_i;;
   endif;

   eofloop = eof(fhparticles);

endo;

closeall;


// close log
output off;

end;

//#include simulate_sunspot.src;
//#include basis_temp.src;
//#include hpdint.src
