/******************************************************************/
/* filename :       dsge_simulate.g                               */
/* Description:                                                   */
/*                                                                */
/******************************************************************/

new;
closeall; 
cls;

#include dsge_spec.g; 

//simulate data from DSGE model

rndseed 123;

T         = 20;
Tdrop     = 0;
shocks_in = rndn(T+Tdrop,3); 
//shocks_in = zeros(T+Tdrop,3);
theta_in  = theta;
ncoefs    = rows(theta)/8;

//scale shocks
shocks_in[.,1] = sigR*shocks_in[.,1];
shocks_in[.,2] = sigg*shocks_in[.,2];
shocks_in[.,3] = sigz*shocks_in[.,3];


// simulate observations
// init: R_lag, y_lag, z_lag, g_lag, A_lag
// outsim:
// 1=pis, 2=Rs, 3=cs, 4=ys, 5=ee1s, 
// 6=ers, 7=zs, 8=gs, 9=CCs, 10=YYs, 11=As
// 12=sun, 13=Rlag, 14=ylag

// compute steady states
{bet,r,gam,pibar,pi_ss,c_ss,y_ss,R_ss,ee1_ss,
 pi_tilde,c_tilde,y_tilde,R_tilde,ee1_tilde} = dsgestst(para,msel);

init_ss    = R_ss|y_ss|0|ln(gstar)|1;
init_sun   = 1;

sim_length = T+Tdrop;
//sun_sim    = get_sunspot(sim_length,init_sun,0,1);
sun_sim    = ones(5,1) | zeros(5,1) | ones(5,1) | zeros(5,1);
outsim     = simulate_sunspot(theta_in,shocks_in,init_ss,sun_sim,Tdrop);

"shocks_in";
shocks_in;

"sun_sim";
sun_sim;

"outsim[.,1:6]";
outsim[.,1:6];

"output growth, inflation and interest rates";
100*ln(outsim[2:T,10]./outsim[1:T-1,10])~400*ln(outsim[2:T,1])~400*ln(outsim[2:T,2]);


end;

#include simulate_sunspot.src;
#include basis_temp.src;
#include get_sunspot.src;
#include dsge_linearmod.src;
